JSB.newAddon = function(mainPath) {
    var baseUrl =function (name,note,list) {
         Name="title="+name;
         Note="&notes="+note;
         List="&list="+list;
         UrlHead="things:///add?";
let thingsurl =UrlHead+Name+Note+List;
return thingsurl;
};
    //MARK: - Customized functions
    // URL generation
    // Open things
    function openUrlWithExternalBrowser(url) {
        // endoce URL to utf-8. NSURL cannot handle Chinese url
        let encodedUrl = encodeURI(url);
        UIApplication.sharedApplication().openURL(NSURL.URLWithString(encodedUrl));
    }
    //MARK - Addon Class definition
    var newAddonClass= JSB.defineClass('ThingsPlugIn : JSExtension', {
        //Mark: - Instance Method Definitions
        // Window initialize
        sceneWillConnect: function() {
         self.webController = WebViewController.new();
        },
        // Window disconnect
        sceneDidDisconnect: function() {
        },
        // Window resign active
        sceneWillResignActive: function() {
        },
        // Window become active
        sceneDidBecomeActive: function() {
        },
        //MARK: MN behaviors
        notebookWillOpen: function(notebookid) {
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
            
            self.thingsPlugInIsOn = NSUserDefaults.standardUserDefaults().objectForKey('marginnote_ThingsPlugIn');
        },
        notebookWillClose: function(notebookid) {
                      NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnNote');
        },
        documentDidOpen: function(docmd5) {
        },
        docmentWillClose: function(docmd5) {
        },
        controllerWillLayoutSubviews: function(controller) {
        },
        queryAddonCommandStatus: function() {
            if(Application.sharedInstance().studyController(self.window).studyMode < 3) {
                return {
                    image: 'ThingsPlugIn.png',
                    object: self,
                    selector: "toggleThingsPlugIn:",
                    checked: self.ThingsPlugInIsOn
                };
            }
            return null;
        },

        // Select text and open the external Browser to process the selected Text
        onPopupMenuOnNote: function (sender) {
            if (!Application.sharedInstance().checkNotifySenderInWindow(sender, self.window)) return;//Don't process message from other window
            if (!self.ThingsPlugInIsOn) return;
            let note = sender.userInfo.note;
            let titleText = note.noteTitle;
            let excerptText = note.excerptText.replace(/\*\*/g, '');
            let text1 = titleText || excerptText;
            let text2 = "！";
            let text3 = note.noteId;
            let text4 = "marginnote3app://note/"+text3;
            let text5 =Application.sharedInstance().studyController().readerController.currentDocumentController.document.docTitle;
            let text = text1 + text2 +text3;
            if (text && text.length) {
                let url = baseUrl(text1,text4,text5);
                openUrlWithExternalBrowser(url);
            }
},
        // Add-On Switch
        toggleThingsPlugIn: function(sender) {
            var lan = NSLocale.preferredLanguages().length ? NSLocale.preferredLanguages()[0].substring(0, 2) : 'en';
            let tips = lan === 'zh' ? 'Things插件已关闭' : 'ThingsPlugIn is off';
            if(self.ThingsPlugInIsOn) {
                self.ThingsPlugInIsOn = false;
            } else {
                self.ThingsPlugInIsOn = true;
                tips = lan === 'zh' ? 'Things插件已开启，任务将自动添加' : 'The ThingsPlugIn is turned on and the task will be added automatically.';
            }
            Application.sharedInstance().showHUD(tips, self.window, 2);
            NSUserDefaults.standardUserDefaults().setObjectForKey(self.ThingsPlugInIsOn, 'marginnote_ThingsPlugIn');
            Application.sharedInstance().studyController(self.window).refreshAddonCommands();
        },
    }, {
        //MARK: - Class Method Definitions
        addonDidConnect: function() {
        },
        addonWillDisconnect: function() {
        },
        applicationWillEnterForeground: function() {
        },
        applicationDidEnterBackground: function() {
        z},
        applicationDidReceiveLocalNotification: function(notify) {
        },
    });
    return newAddonClass;
};
